## kew 2.0.3+ds

=== Makefile ===
CC = gcc
PKG_CONFIG	?= pkg-config
CFLAGS = -I/usr/include -I/usr/include/ogg -I/usr/include/opus -I/usr/include/stb -Iinclude/imgtotxt/ext -Iinclude/imgtotxt -I/usr/include/ffmpeg -I/usr/include/glib-2.0 -I/usr/lib/glib-2.0/include -Iinclude/miniaudio -O2 $(shell $(PKG_CONFIG) --cflags gio-2.0 chafa fftw3f opus opusfile vorbis)
CFLAGS += -fstack-protector-strong -Wformat -Werror=format-security -fPIE -fstack-protector -fstack-protector-strong -D_FORTIFY_SOURCE=2
CFLAGS += -Wall -Wpointer-arith
LIBS = -L/usr/lib -lfreeimage -latomic -lpthread -lrt -pthread -lm -lglib-2.0  $(shell $(PKG_CONFIG) --libs gio-2.0 chafa fftw3f opus opusfile vorbis vorbisfile)
LDFLAGS = -pie -Wl,-z,relro

OBJDIR = src/obj
PREFIX = /usr
SRCS = src/directorytree.c src/soundcommon.c src/player.c src/soundopus.c src/soundvorbis.c src/soundbuiltin.c src/soundpcm.c src/mpris.c src/playerops.c src/volume.c src/cutils.c src/soundgapless.c src/songloader.c src/file.c src/chafafunc.c src/cache.c src/metadata.c src/playlist.c src/stringfunc.c src/term.c  src/settings.c src/albumart.c src/visuals.c src/kew.c
OBJS = $(SRCS:src/%.c=$(OBJDIR)/%.o)

MAN_PAGE = kew.1
MAN_DIR ?= $(PREFIX)/share/man

all: kew

$(OBJDIR)/%.o: src/%.c Makefile | $(OBJDIR)
	$(CC) $(CFLAGS) -c -o $@ $<

$(OBJDIR)/write_ascii.o: include/imgtotxt/write_ascii.c Makefile | $(OBJDIR)
	$(CC) $(CFLAGS) -c -o $@ $< $(LDFLAGS)

$(OBJDIR):
	mkdir -p $(OBJDIR)

kew: $(OBJDIR)/write_ascii.o $(OBJS) Makefile
	$(CC) -o kew $(OBJDIR)/write_ascii.o $(OBJS) $(LIBS)

.PHONY: install
install: all
	mkdir -p $(DESTDIR)$(MAN_DIR)/man1
	mkdir -p $(DESTDIR)$(PREFIX)/bin
	install -m 0755 kew $(DESTDIR)$(PREFIX)/bin/kew
	install -m 0644 docs/kew.1 $(DESTDIR)$(MAN_DIR)/man1/kew.1

.PHONY: uninstall
uninstall:
	rm -f $(DESTDIR)$(PREFIX)/bin/kew
	rm -f $(DESTDIR)$(MAN_DIR)/man1/kew.1

.PHONY: clean
clean:
	rm -rf $(OBJDIR) kew

=== debian/changelog ===
kew (2.0.3+ds-2) unstable; urgency=medium

  * Added patch to fix build on HURD 

 -- Matthias Geiger <werdahias@riseup.net>  Fri, 19 Jan 2024 14:23:42 +0100

kew (2.0.3+ds-1) unstable; urgency=medium

  * New upstream release
  * Re-added patch for -g gcc flag in makefile

 -- Matthias Geiger <werdahias@riseup.net>  Sun, 14 Jan 2024 22:10:12 +0100

kew (1.11+ds-1) unstable; urgency=medium

  * New upstream release
  * Drop patches; upstreamed

 -- Matthias Geiger <werdahias@riseup.net>  Sun, 10 Dec 2023 19:23:19 +0100

kew (1.9+ds-1) unstable; urgency=medium

  * New upstream release
  * Extend hurd patch

 -- Matthias Geiger <werdahias@riseup.net>  Sat, 02 Dec 2023 19:16:33 +0100

kew (1.8+ds-1) unstable; urgency=medium

  * New upstream release
  * Fixed watchfile to correctly monitor releases
  * Drop armel-compilation patch, upstreamed
  * Added patch for hurd

 -- Matthias Geiger <werdahias@riseup.net>  Tue, 28 Nov 2023 23:46:56 +0100

kew (1.7.0+ds-1) unstable; urgency=medium

  * New upstream release
  * Removed old references to cue from d/control, d/watch and d/copyright
  * Removed hurd patch; upstreamed
  * Improved description in d/control
  * Added new dependencies in d/control
  * Refresh patch for new dependencies
  * Versioned dependency on miniaudio in d/control
  * Rebased patch for new upstream

 -- Matthias Geiger <werdahias@riseup.net>  Thu, 23 Nov 2023 21:07:08 +0100

kew (1.5.2+ds-2) unstable; urgency=medium

  * Add patches to fix build failures on armel and hurd

 -- Matthias Geiger <werdahias@riseup.net>  Wed, 15 Nov 2023 19:02:14 +0100

kew (1.5.2+ds-1) unstable; urgency=medium

  * Initial release. (Closes: #1055232)

 -- Matthias Geiger <werdahias@riseup.net>  Sun, 12 Nov 2023 22:58:09 +0100

=== debian/control ===
Source: kew
Section: sound
Priority: optional
Maintainer: Matthias Geiger <werdahias@riseup.net>
Rules-Requires-Root: no
Build-Depends:
 debhelper-compat (= 13),
 libavformat-dev,
 libchafa-dev,
 libfftw3-dev,
 libfreeimage-dev,
 libglib2.0-dev,
 libminiaudio-dev (>= 0.11.21~~),
 libstb-dev,
 libopus-dev,
 libopusfile-dev,
 libvorbis-dev,
Standards-Version: 4.6.2
Homepage: https://github.com/ravachol/kew
Vcs-Browser: https://salsa.debian.org/debian/kew
Vcs-Git: https://salsa.debian.org/debian/kew.git

Package: kew
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
Description: play music from the commandline
 kew is a commandline music player. It supports gapless playback,
 displaying album covers as ASCII art or as a normal image,
 and 24-bit audio. Saving a current selection of songs as m3u is
 also supported.

## kew 2.3.1+ds

=== debian/changelog ===
kew (2.3.1+ds-1) unstable; urgency=medium

  * New upstream release
  * Add libnotify-bin as Recommends: for notification support

 -- Matthias Geiger <werdahias@riseup.net>  Tue, 13 Feb 2024 00:07:25 +0100

kew (2.2.1+ds-1) unstable; urgency=medium

  * New upstream release
  * Rebase patch for new upstream

 -- Matthias Geiger <werdahias@riseup.net>  Thu, 08 Feb 2024 18:28:04 +0100

kew (2.1.1+ds-1) unstable; urgency=medium

  * New upstream release

 -- Matthias Geiger <werdahias@riseup.net>  Sun, 28 Jan 2024 14:47:34 +0100

=== debian/control ===
--- 
+++ 
@@ -25,6 +25,7 @@
 Depends:
  ${shlibs:Depends},
  ${misc:Depends},
+Recommends: libnotify-bin
 Description: play music from the commandline
  kew is a commandline music player. It supports gapless playback,
  displaying album covers as ASCII art or as a normal image,

## kew 2.4.2%2Bds

=== Makefile ===
CC = gcc
PKG_CONFIG	?= pkg-config
CFLAGS = -I/usr/include -I/usr/include/ogg -I/usr/include/opus -I/usr/include/stb -Iinclude/imgtotxt/ext -Iinclude/imgtotxt -I/usr/include/ffmpeg -I/usr/include/glib-2.0 -I/usr/lib/glib-2.0/include -Iinclude/miniaudio -O2 $(shell $(PKG_CONFIG) --cflags libavcodec libavutil libavformat libswresample gio-2.0 chafa fftw3f opus opusfile vorbis)
CFLAGS += -fstack-protector-strong -Wformat -Werror=format-security -fPIE -fstack-protector -fstack-protector-strong -D_FORTIFY_SOURCE=2
CFLAGS += -Wall -Wextra -Wpointer-arith
LIBS = -L/usr/lib -lfreeimage -lpthread -lrt -pthread -lm -lglib-2.0  $(shell $(PKG_CONFIG) --libs libavcodec libavutil libavformat libswresample gio-2.0 chafa fftw3f opus opusfile vorbis vorbisfile)

ifeq ($(CC),gcc)
    LIBS += -latomic
endif

LDFLAGS = -pie -Wl,-z,relro

OBJDIR = src/obj
PREFIX = /usr
SRCS = src/sound.c src/directorytree.c src/soundcommon.c src/player.c src/soundbuiltin.c src/mpris.c src/playerops.c src/utils.c src/file.c src/chafafunc.c src/cache.c src/songloader.c src/playlist.c src/term.c  src/settings.c src/visuals.c src/kew.c
OBJS = $(SRCS:src/%.c=$(OBJDIR)/%.o)

MAN_PAGE = kew.1
MAN_DIR ?= $(PREFIX)/share/man

all: kew

$(OBJDIR)/%.o: src/%.c Makefile | $(OBJDIR)
	$(CC) $(CFLAGS) -c -o $@ $<

$(OBJDIR)/write_ascii.o: include/imgtotxt/write_ascii.c Makefile | $(OBJDIR)
	$(CC) $(CFLAGS) -c -o $@ $< $(LDFLAGS)

$(OBJDIR):
	mkdir -p $(OBJDIR)

kew: $(OBJDIR)/write_ascii.o $(OBJS) Makefile
	$(CC) -o kew $(OBJDIR)/write_ascii.o $(OBJS) $(LIBS)

.PHONY: install
install: all
	mkdir -p $(DESTDIR)$(MAN_DIR)/man1
	mkdir -p $(DESTDIR)$(PREFIX)/bin
	install -m 0755 kew $(DESTDIR)$(PREFIX)/bin/kew
	install -m 0644 docs/kew.1 $(DESTDIR)$(MAN_DIR)/man1/kew.1

.PHONY: uninstall
uninstall:
	rm -f $(DESTDIR)$(PREFIX)/bin/kew
	rm -f $(DESTDIR)$(MAN_DIR)/man1/kew.1

.PHONY: clean
clean:
	rm -rf $(OBJDIR) kew

## kew 2.4.2+ds

=== debian/changelog ===
kew (2.4.2+ds-1build1) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 17:07:47 +1100

kew (2.4.2+ds-1) unstable; urgency=medium

  * New upstream release
  * Updated urls in d/upstream/metadata
  * Rebase patches for new upstream

 -- Matthias Geiger <werdahias@riseup.net>  Fri, 01 Mar 2024 21:35:32 +0100

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,8 @@
 Source: kew
 Section: sound
 Priority: optional
-Maintainer: Matthias Geiger <werdahias@riseup.net>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Matthias Geiger <werdahias@riseup.net>
 Rules-Requires-Root: no
 Build-Depends:
  debhelper-compat (= 13),

## kew 2.5.0+ds

=== debian/changelog ===
kew (2.5.0+ds-1) unstable; urgency=medium

  * New upstream release
  * Refresh makefile patch for new upstream release

 -- Matthias Geiger <werdahias@riseup.net>  Thu, 20 Jun 2024 23:48:05 +0200

kew (2.4.4+ds-1) unstable; urgency=medium

  * New upstream release
  * Bump Standards-Version to 4.7.0; no changes needed
  * Mention sixel requirement in d/control

 -- Matthias Geiger <werdahias@riseup.net>  Sun, 21 Apr 2024 14:33:18 +0200

kew (2.4.3+ds-1) unstable; urgency=medium

  * New upstream release

 -- Matthias Geiger <werdahias@riseup.net>  Wed, 20 Mar 2024 21:54:58 +0100

## kew 2.6.0+ds

=== Makefile ===
--- 
+++ 
@@ -1,19 +1,18 @@
 CC = gcc
 PKG_CONFIG	?= pkg-config
-CFLAGS = -I/usr/include -I/usr/include/ogg -I/usr/include/opus -I/usr/include/stb -Iinclude/imgtotxt/ext -Iinclude/imgtotxt -I/usr/include/ffmpeg -I/usr/include/glib-2.0 -I/usr/lib/glib-2.0/include -Iinclude/miniaudio -O2 $(shell $(PKG_CONFIG) --cflags libavcodec libavutil libavformat libswresample gio-2.0 chafa fftw3f opus opusfile vorbis)
+CFLAGS = -I/usr/include -I/usr/include/ogg -I/usr/include/opus -I/usr/include/stb -Iinclude/imgtotxt/ext -Iinclude/imgtotxt -I/usr/include/ffmpeg -I/usr/include/glib-2.0 -I/usr/lib/glib-2.0/include -Iinclude/miniaudio -O1 $(shell $(PKG_CONFIG) --cflags libavcodec libavutil libavformat libswresample gio-2.0 chafa fftw3f opus opusfile vorbis)
 CFLAGS += -fstack-protector-strong -Wformat -Werror=format-security -fPIE -fstack-protector -fstack-protector-strong -D_FORTIFY_SOURCE=2
 CFLAGS += -Wall -Wextra -Wpointer-arith
 LIBS = -L/usr/lib -lfreeimage -lpthread -lrt -pthread -lm -lglib-2.0  $(shell $(PKG_CONFIG) --libs libavcodec libavutil libavformat libswresample gio-2.0 chafa fftw3f opus opusfile vorbis vorbisfile)
+LDFLAGS = -pie -Wl,-z,relro
 
 ifeq ($(CC),gcc)
     LIBS += -latomic
 endif
 
-LDFLAGS = -pie -Wl,-z,relro
-
 OBJDIR = src/obj
 PREFIX = /usr
-SRCS = src/sound.c src/directorytree.c src/soundcommon.c src/player.c src/soundbuiltin.c src/mpris.c src/playerops.c src/utils.c src/file.c src/chafafunc.c src/cache.c src/songloader.c src/playlist.c src/term.c  src/settings.c src/visuals.c src/kew.c
+SRCS = src/common_ui.c src/sound.c src/directorytree.c src/soundcommon.c src/search_ui.c src/playlist_ui.c src/player.c src/soundbuiltin.c src/mpris.c src/playerops.c src/utils.c src/file.c src/chafafunc.c src/cache.c src/songloader.c src/playlist.c src/term.c  src/settings.c src/visuals.c src/kew.c
 OBJS = $(SRCS:src/%.c=$(OBJDIR)/%.o)
 
 MAN_PAGE = kew.1

=== debian/changelog ===
kew (2.6.0+ds-1build1) oracular; urgency=medium

  * Rebuild against new libavcodec61.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 31 Jul 2024 17:14:28 +0200

kew (2.6.0+ds-1) unstable; urgency=medium

  * New upstream release

 -- Matthias Geiger <werdahias@riseup.net>  Fri, 05 Jul 2024 22:20:33 +0200

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,7 @@
 Source: kew
 Section: sound
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Matthias Geiger <werdahias@riseup.net>
+Maintainer: Matthias Geiger <werdahias@riseup.net>
 Rules-Requires-Root: no
 Build-Depends:
  debhelper-compat (= 13),
@@ -16,7 +15,7 @@
  libopus-dev,
  libopusfile-dev,
  libvorbis-dev,
-Standards-Version: 4.6.2
+Standards-Version: 4.7.0
 Homepage: https://github.com/ravachol/kew
 Vcs-Browser: https://salsa.debian.org/debian/kew
 Vcs-Git: https://salsa.debian.org/debian/kew.git
@@ -32,3 +31,6 @@
  displaying album covers as ASCII art or as a normal image,
  and 24-bit audio. Saving a current selection of songs as m3u is
  also supported.
+ .
+ Note: For proper cover display a terminal with sixel support is needed,
+ such as Konsole or foot.

## kew 2.8.2+ds

=== Makefile ===
CC ?= gcc
PKG_CONFIG ?= pkg-config

# Default USE_LIBNOTIFY to auto-detect if not set by user
ifeq ($(origin USE_LIBNOTIFY), undefined)
  ifneq ($(shell $(PKG_CONFIG) --exists libnotify && echo yes),yes)
    USE_LIBNOTIFY = 0
  else
    USE_LIBNOTIFY = 1
  endif
endif

CFLAGS = -I/usr/include -I/usr/include/chafa -I/usr/lib/chafa/include -I/usr/include/ogg -I/usr/include/opus -I/usr/include/stb -Iinclude/imgtotxt/ext -Iinclude/imgtotxt -I/usr/include/ffmpeg -I/usr/include/glib-2.0 -I/usr/lib/glib-2.0/include -Iinclude/miniaudio -I/usr/include/gdk-pixbuf-2.0 -O1 $(shell $(PKG_CONFIG) --cflags libavcodec libavutil libavformat libswresample gio-2.0 chafa fftw3f opus opusfile vorbis glib-2.0)
CFLAGS += -fstack-protector-strong -Wformat -Werror=format-security -fPIE -fstack-protector -fstack-protector-strong -D_FORTIFY_SOURCE=2
CFLAGS += -Wall -Wextra -Wpointer-arith

LIBS = -L/usr/lib -lfreeimage -lpthread -lrt -pthread -lm -lglib-2.0 $(shell $(PKG_CONFIG) --libs libavcodec libavutil libavformat libswresample gio-2.0 chafa fftw3f opus opusfile vorbis vorbisfile glib-2.0)
LDFLAGS = -pie -Wl,-z,relro,-lz

# Conditionally add libnotify if USE_LIBNOTIFY is enabled
ifeq ($(USE_LIBNOTIFY), 1)
  CFLAGS += $(shell $(PKG_CONFIG) --cflags libnotify)
  LIBS += -lnotify
  DEFINES += -DUSE_LIBNOTIFY
endif

ifeq ($(CC), gcc)
    LIBS += -latomic
endif

OBJDIR = src/obj
PREFIX = /usr
SRCS = src/common_ui.c src/sound.c src/directorytree.c src/soundcommon.c src/search_ui.c src/playlist_ui.c src/player.c src/soundbuiltin.c src/mpris.c src/playerops.c src/utils.c src/file.c src/chafafunc.c src/cache.c src/songloader.c src/playlist.c src/term.c src/settings.c src/visuals.c src/kew.c
OBJS = $(SRCS:src/%.c=$(OBJDIR)/%.o)

MAN_PAGE = kew.1
MAN_DIR ?= $(PREFIX)/share/man

all: kew

$(OBJDIR)/%.o: src/%.c Makefile | $(OBJDIR)
	$(CC) $(CFLAGS) $(DEFINES) -c -o $@ $<

$(OBJDIR)/write_ascii.o: include/imgtotxt/write_ascii.c Makefile | $(OBJDIR)
	$(CC) $(CFLAGS) $(DEFINES) -c -o $@ $<

$(OBJDIR):
	mkdir -p $(OBJDIR)

kew: $(OBJDIR)/write_ascii.o $(OBJS) Makefile
	$(CC) -o kew $(OBJDIR)/write_ascii.o $(OBJS) $(LIBS) $(LDFLAGS)

.PHONY: install
install: all
	mkdir -p $(DESTDIR)$(MAN_DIR)/man1
	mkdir -p $(DESTDIR)$(PREFIX)/bin
	install -m 0755 kew $(DESTDIR)$(PREFIX)/bin/kew
	install -m 0644 docs/kew.1 $(DESTDIR)$(MAN_DIR)/man1/kew.1

.PHONY: uninstall
uninstall:
	rm -f $(DESTDIR)$(PREFIX)/bin/kew
	rm -f $(DESTDIR)$(MAN_DIR)/man1/kew.1

.PHONY: clean
clean:
	rm -rf $(OBJDIR) kew

=== debian/changelog ===
kew (2.8.2+ds-2) unstable; urgency=medium

  * Add patch to force enabling of libatomic
  * d/p/fix-hurd-build: Extend for new upstream release
  * d/p/reeable-g-flag.diff: Refresh for new patchset

 -- Matthias Geiger <werdahias@debian.org>  Fri, 04 Oct 2024 00:36:13 +0200

kew (2.8.2+ds-1) unstable; urgency=medium

  * New upstream release
  * d/p/fix-hurd-build.diff: refresh for new upstream
  * d/p/reenable-g-flag.diff: refresh for new upstream

 -- Matthias Geiger <werdahias@debian.org>  Tue, 24 Sep 2024 22:24:31 +0200

kew (2.7.2+ds-1) unstable; urgency=medium

  * New upstream release

 -- Matthias Geiger <werdahias@debian.org>  Fri, 06 Sep 2024 23:16:24 +0200

kew (2.7.1+ds-1) unstable; urgency=medium

  * New upstream release
  * Refresh makefile patch
  * Build-depend on libnotify-dev; drop libnotify-bin from Recommends
  * d/control, d/copyright: Updated my mail address

 -- Matthias Geiger <werdahias@debian.org>  Tue, 27 Aug 2024 10:52:27 +0200

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,7 @@
 Source: kew
 Section: sound
 Priority: optional
-Maintainer: Matthias Geiger <werdahias@riseup.net>
+Maintainer: Matthias Geiger <werdahias@debian.org>
 Rules-Requires-Root: no
 Build-Depends:
  debhelper-compat (= 13),
@@ -10,6 +10,7 @@
  libfftw3-dev,
  libfreeimage-dev,
  libglib2.0-dev,
+ libnotify-dev,
  libminiaudio-dev (>= 0.11.21~~),
  libstb-dev,
  libopus-dev,
@@ -25,7 +26,6 @@
 Depends:
  ${shlibs:Depends},
  ${misc:Depends},
-Recommends: libnotify-bin
 Description: play music from the commandline
  kew is a commandline music player. It supports gapless playback,
  displaying album covers as ASCII art or as a normal image,

=== debian/watch ===
version=4
opts=\
repacksuffix=+ds,\
repack,compression=gz,\
dversionmangle=s/\+(ds)(\.\d+)?$//,\
filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/kew-$1\.tar\.gz/ \
  https://github.com/ravachol/kew/tags  .*/v?(\d\S*)@ARCHIVE_EXT@

## kew 3.0.3+ds

=== debian/changelog ===
kew (3.0.3+ds-1) unstable; urgency=medium

  * New upstream release
  * d/patches: Drop upstreamed patches; refresh remaining patch
  * d/control: Update build-dependecies, sort them
  * d/control: Update S-V to 4.7.2, no changes needed
  * d/copyright: Update for new upstream
  * d/copyright: Adjust excluded files

 -- Matthias Geiger <werdahias@debian.org>  Thu, 27 Feb 2025 23:00:49 +0100

=== debian/control ===
--- 
+++ 
@@ -7,16 +7,19 @@
  debhelper-compat (= 13),
  libavformat-dev,
  libchafa-dev,
+ libfaad-dev,
  libfftw3-dev,
  libfreeimage-dev,
  libglib2.0-dev,
  libnotify-dev,
  libminiaudio-dev (>= 0.11.21~~),
- libstb-dev,
+ libogg-dev,
  libopus-dev,
  libopusfile-dev,
+ libstb-dev,
+ libtag1-dev,
  libvorbis-dev,
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Homepage: https://github.com/ravachol/kew
 Vcs-Browser: https://salsa.debian.org/debian/kew
 Vcs-Git: https://salsa.debian.org/debian/kew.git

## kew 3.1.2+ds

=== Makefile ===
CC ?= gcc
CXX ?= g++
PKG_CONFIG ?= pkg-config

# To enable debugging, run:
# make DEBUG=1
# To disable DBUS notifications, run:
# make USE_DBUS=0
# To disable faad2, run:
# make USE_FAAD=0

# Detect system and architecture
UNAME_S := $(shell uname -s)
ARCH := $(shell uname -m)

# Default USE_DBUS to auto-detect if not set by user
ifeq ($(origin USE_DBUS), undefined)
  ifeq ($(UNAME_S), Darwin)
    USE_DBUS = 0
  else
    USE_DBUS = 1
  endif
endif

# Adjust the PREFIX for macOS and Linux
ifeq ($(UNAME_S), Darwin)
    ifeq ($(ARCH), arm64)
        PREFIX ?= /usr/local
        PKG_CONFIG_PATH := /opt/homebrew/lib/pkgconfig:/opt/homebrew/share/pkgconfig:$(PKG_CONFIG_PATH)
    else
        PREFIX ?= /usr/local
        PKG_CONFIG_PATH := /usr/local/lib/pkgconfig:/usr/local/share/pkgconfig:$(PKG_CONFIG_PATH)
    endif
else
    PREFIX ?= /usr
    PKG_CONFIG_PATH := /usr/lib/pkgconfig:/usr/share/pkgconfig:$(PKG_CONFIG_PATH)
endif

# Default USE_FAAD to auto-detect if not set by user
ifeq ($(origin USE_FAAD), undefined)

  USE_FAAD = $(shell PKG_CONFIG_PATH=$(PKG_CONFIG_PATH) $(PKG_CONFIG) --exists faad && echo 1 || echo 0)

  ifeq ($(USE_FAAD), 0)
    # If pkg-config fails, try to find libfaad dynamically in common paths
    USE_FAAD = $(shell [ -f /usr/lib/libfaad.so ] || [ -f /usr/local/lib/libfaad.so ] || \
                       [ -f /opt/local/lib/libfaad.so ] || [ -f /opt/homebrew/lib/libfaad.dylib ] || \
                       [ -f /opt/homebrew/opt/faad2/lib/libfaad.dylib ] || \
                       [ -f /usr/local/lib/libfaad.dylib ] || [ -f /lib/x86_64-linux-gnu/libfaad.so.2 ] && echo 1 || echo 0)
  endif
endif

# Compiler flags
COMMONFLAGS = -I/usr/include -I/opt/homebrew/include -I/usr/local/include -I/usr/lib -Iinclude/minimp4 \
         -I/usr/include/chafa -I/usr/lib/chafa/include -I/usr/include/ogg -I/usr/include/opus \
         -I/usr/include/stb -Iinclude/stb_image -Iinclude/alac/codec -I/usr/include/glib-2.0 \
         -I/usr/lib/glib-2.0/include -Iinclude/miniaudio -I/usr/include/gdk-pixbuf-2.0

ifeq ($(DEBUG), 1)
COMMONFLAGS += -g
else
COMMONFLAGS += -O2
endif

COMMONFLAGS += $(shell PKG_CONFIG_PATH=$(PKG_CONFIG_PATH) $(PKG_CONFIG) --cflags gio-2.0 chafa fftw3f opus opusfile vorbis ogg glib-2.0 taglib)
COMMONFLAGS += -fstack-protector-strong -Wformat -Werror=format-security -fPIE -D_FORTIFY_SOURCE=2
COMMONFLAGS += -Wall -Wextra -Wpointer-arith -flto
CFLAGS = $(COMMONFLAGS)

# Compiler flags for C++ code
CXXFLAGS = $(COMMONFLAGS) -std=c++11

# Libraries
LIBS = -L/usr/lib -lm -lopusfile -lcurl -lglib-2.0 -lpthread $(shell PKG_CONFIG_PATH=$(PKG_CONFIG_PATH) $(PKG_CONFIG) --libs gio-2.0 chafa fftw3f opus opusfile ogg vorbis vorbisfile glib-2.0 taglib)
LIBS += -lstdc++

LDFLAGS = -logg -lz -flto

ifeq ($(UNAME_S), Linux)
  CFLAGS += -fPIE -fstack-clash-protection
  CXXFLAGS += -fPIE -fstack-clash-protection
  LDFLAGS += -pie -Wl,-z,relro
  ifneq (,$(filter $(ARCH), x86_64 i386))
        CFLAGS += -fcf-protection
        CXXFLAGS += -fcf-protection
  endif
  ifneq ($(DEBUG), 1)
  LDFLAGS += -s
  endif
endif

# Conditionally add  USE_DBUS is enabled
ifeq ($(USE_DBUS), 1)
  DEFINES += -DUSE_DBUS
endif

# Conditionally add faad2 support if USE_FAAD is enabled
ifeq ($(USE_FAAD), 1)
  ifeq ($(ARCH), arm64)
    CFLAGS += -I/opt/homebrew/opt/faad2/include
    LIBS += -L/opt/homebrew/opt/faad2/lib -lfaad
  else
    CFLAGS += -I/usr/local/include
    LIBS += -L/usr/local/lib -lfaad
  endif
  DEFINES += -DUSE_FAAD
endif

ifeq ($(origin CC),default)
    CC := gcc
endif

ifneq ($(findstring gcc,$(CC)),)
    ifeq ($(UNAME_S), Linux)
        LIBS += -latomic
    endif
endif

OBJDIR = src/obj

SRCS = src/common_ui.c  src/common.c src/sound.c src/directorytree.c src/notifications.c \
       src/soundcommon.c src/m4a.c src/search_ui.c  src/soundradio.c src/searchradio_ui.c  src/playlist_ui.c \
       src/player.c src/soundbuiltin.c src/mpris.c src/playerops.c \
       src/utils.c src/file.c src/imgfunc.c src/cache.c src/songloader.c \
       src/playlist.c src/term.c src/settings.c src/visuals.c src/kew.c

# TagLib wrapper
WRAPPER_SRC = src/tagLibWrapper.cpp
WRAPPER_OBJ = $(OBJDIR)/tagLibWrapper.o

MAN_PAGE = kew.1
MAN_DIR ?= $(PREFIX)/share/man

all: kew

# ALAC codec sources
ALAC_SRCS_CPP = include/alac/codec/ALACDecoder.cpp include/alac/codec/alac_wrapper.cpp
ALAC_SRCS_C = include/alac/codec/ag_dec.c include/alac/codec/ALACBitUtilities.c \
              include/alac/codec/dp_dec.c include/alac/codec/EndianPortable.c \
              include/alac/codec/matrix_dec.c

# Generate object lists
OBJS_C = $(SRCS:src/%.c=$(OBJDIR)/%.o) $(ALAC_SRCS_C:include/alac/codec/%.c=$(OBJDIR)/alac/%.o)
OBJS_CPP = $(ALAC_SRCS_CPP:include/alac/codec/%.cpp=$(OBJDIR)/alac/%.o)

# All objects together
OBJS = $(OBJS_C) $(OBJS_CPP)

# Create object directories
$(OBJDIR):
	mkdir -p $(OBJDIR) $(OBJDIR)/alac

## Compile C sources
$(OBJDIR)/%.o: src/%.c Makefile | $(OBJDIR)
	@mkdir -p $(dir $@)
	$(CC) $(CFLAGS) $(DEFINES) -c -o $@ $<

# Compile ALAC C files
$(OBJDIR)/alac/%.o: include/alac/codec/%.c Makefile | $(OBJDIR)
	@mkdir -p $(dir $@)
	$(CC) $(CFLAGS) $(DEFINES) -c -o $@ $<

# Compile ALAC C++ files
$(OBJDIR)/alac/%.o: include/alac/codec/%.cpp Makefile | $(OBJDIR)
	@mkdir -p $(dir $@)
	$(CXX) $(CXXFLAGS) $(DEFINES) -c -o $@ $<

# Compile explicit C++ sources in src/
$(OBJDIR)/%.o: src/%.cpp Makefile | $(OBJDIR)
	@mkdir -p $(dir $@)
	$(CXX) $(CXXFLAGS) $(DEFINES) -c -o $@ $<

# Compile TagLib wrapper C++ source
$(WRAPPER_OBJ): $(WRAPPER_SRC) Makefile | $(OBJDIR)
	@mkdir -p $(dir $@)
	$(CXX) $(CXXFLAGS) $(DEFINES) -c $< -o $@

# Link all objects safely together using C++ linker
kew: $(OBJS) $(WRAPPER_OBJ) Makefile
	$(CXX) -o kew $(OBJS) $(WRAPPER_OBJ) $(LIBS) $(LDFLAGS)

.PHONY: install
install: all
	mkdir -p $(DESTDIR)$(MAN_DIR)/man1
	mkdir -p $(DESTDIR)$(PREFIX)/bin
	install -m 0755 kew $(DESTDIR)$(PREFIX)/bin/kew
	install -m 0644 docs/kew.1 $(DESTDIR)$(MAN_DIR)/man1/kew.1

.PHONY: uninstall
uninstall:
	rm -f $(DESTDIR)$(PREFIX)/bin/kew
	rm -f $(DESTDIR)$(MAN_DIR)/man1/kew.1

.PHONY: clean
clean:
	rm -rf $(OBJDIR) kew

=== debian/changelog ===
kew (3.1.2+ds-1) unstable; urgency=medium

  * New upstream release
  * d/copyright: Update for new upstream
  * d/patches: Drop patches applied upstream
  * d/rules: Explicitly enable debug symbols
  * d/control: s/libtag1-dev/libtag-dev (Closes: #1101202)
  * d/control: Require libstb >= 0.0~git20241109.5c20573+ds-1
  * d/control: Add new dependency on curl
  * d/copyright: Exclude stb_image

 -- Matthias Geiger <werdahias@debian.org>  Tue, 25 Mar 2025 19:34:48 +0100

kew (3.0.3+ds-4) unstable; urgency=medium

  * d/p/fix-hurd-build.diff: Extend some more

 -- Matthias Geiger <werdahias@debian.org>  Sun, 09 Mar 2025 18:16:11 +0100

kew (3.0.3+ds-3) unstable; urgency=medium

  * Fix makefile patch (thanks to helmut)

 -- Matthias Geiger <werdahias@debian.org>  Sat, 08 Mar 2025 20:52:15 +0100

kew (3.0.3+ds-2) unstable; urgency=medium

  * Add patch to fix build on HURD
  * Add patch adding more hardening flags

 -- Matthias Geiger <werdahias@debian.org>  Sat, 08 Mar 2025 17:39:27 +0100

## kew 3.2.0%2Bds

=== debian/changelog ===
kew (3.2.0+ds-1) unstable; urgency=medium

  * New upstream release

 -- Matthias Geiger <werdahias@debian.org>  Sat, 26 Apr 2025 15:57:05 +0200

=== debian/control ===
--- 
+++ 
@@ -7,6 +7,7 @@
  debhelper-compat (= 13),
  libavformat-dev,
  libchafa-dev,
+ libcurl4-gnutls-dev,
  libfaad-dev,
  libfftw3-dev,
  libfreeimage-dev,
@@ -16,8 +17,8 @@
  libogg-dev,
  libopus-dev,
  libopusfile-dev,
- libstb-dev,
- libtag1-dev,
+ libstb-dev (>= 0.0~git20241109.5c20573+ds-1),
+ libtag-dev,
  libvorbis-dev,
 Standards-Version: 4.7.2
 Homepage: https://github.com/ravachol/kew

## kew 3.2.0+ds

=== Makefile ===
--- 
+++ 
@@ -33,7 +33,7 @@
     endif
 else
     PREFIX ?= /usr
-    PKG_CONFIG_PATH := /usr/lib/pkgconfig:/usr/share/pkgconfig:$(PKG_CONFIG_PATH)
+    PKG_CONFIG_PATH := /usr/lib/x86_64-linux-gnu/pkgconfig:/usr/lib/pkgconfig:/usr/share/pkgconfig:$(PKG_CONFIG_PATH)
 endif
 
 # Default USE_FAAD to auto-detect if not set by user

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEBUG=1

%:
	dh $@

## kew 3.4.0+ds

=== debian/changelog ===
kew (3.4.0+ds-1) unstable; urgency=medium

  * New upstream release
  * d/copyright: Update for new upstream
  * d/control: Drop dependency on libcurl
  * Add patch fixing prefix in makefile
  * d/control: Fix package versioning for libstb
  * d/rules: Delete extra whitespace

 -- Matthias Geiger <werdahias@debian.org>  Sun, 17 Aug 2025 18:16:03 +0200

=== debian/control ===
--- 
+++ 
@@ -7,7 +7,6 @@
  debhelper-compat (= 13),
  libavformat-dev,
  libchafa-dev,
- libcurl4-gnutls-dev,
  libfaad-dev,
  libfftw3-dev,
  libfreeimage-dev,
@@ -17,7 +16,7 @@
  libogg-dev,
  libopus-dev,
  libopusfile-dev,
- libstb-dev (>= 0.0~git20241109.5c20573+ds-1),
+ libstb-dev (>= 0.0~git20241109.5c20573+ds~~),
  libtag-dev,
  libvorbis-dev,
 Standards-Version: 4.7.2

## kew 3.4.1+ds

=== Makefile ===
--- 
+++ 
@@ -32,7 +32,7 @@
         PKG_CONFIG_PATH := /usr/local/lib/pkgconfig:/usr/local/share/pkgconfig:$(PKG_CONFIG_PATH)
     endif
 else
-    PREFIX ?= /usr
+    PREFIX ?= /usr/local
     PKG_CONFIG_PATH := /usr/lib/x86_64-linux-gnu/pkgconfig:/usr/lib/pkgconfig:/usr/share/pkgconfig:$(PKG_CONFIG_PATH)
 endif
 
@@ -53,28 +53,28 @@
 # Compiler flags
 COMMONFLAGS = -I/usr/include -I/opt/homebrew/include -I/usr/local/include -I/usr/lib -Iinclude/minimp4 \
          -I/usr/include/chafa -I/usr/lib/chafa/include -I/usr/include/ogg -I/usr/include/opus \
-         -I/usr/include/stb -Iinclude/stb_image -Iinclude/alac/codec -I/usr/include/glib-2.0 \
-         -I/usr/lib/glib-2.0/include -Iinclude/miniaudio -I/usr/include/gdk-pixbuf-2.0
+         -I/usr/include/stb -Iinclude/stb_image -I/usr/include/glib-2.0 \
+         -I/usr/lib/glib-2.0/include -Iinclude/miniaudio -Iinclude -Iinclude/nestegg -I/usr/include/gdk-pixbuf-2.0
 
 ifeq ($(DEBUG), 1)
-COMMONFLAGS += -g
+COMMONFLAGS += -g -DDEBUG
 else
 COMMONFLAGS += -O2
 endif
 
 COMMONFLAGS += $(shell PKG_CONFIG_PATH=$(PKG_CONFIG_PATH) $(PKG_CONFIG) --cflags gio-2.0 chafa fftw3f opus opusfile vorbis ogg glib-2.0 taglib)
 COMMONFLAGS += -fstack-protector-strong -Wformat -Werror=format-security -fPIE -D_FORTIFY_SOURCE=2
-COMMONFLAGS += -Wall -Wextra -Wpointer-arith -flto
+COMMONFLAGS += -Wall -Wextra -Wpointer-arith
 CFLAGS = $(COMMONFLAGS)
 
 # Compiler flags for C++ code
 CXXFLAGS = $(COMMONFLAGS) -std=c++11
 
 # Libraries
-LIBS = -L/usr/lib -lm -lopusfile -lcurl -lglib-2.0 -lpthread $(shell PKG_CONFIG_PATH=$(PKG_CONFIG_PATH) $(PKG_CONFIG) --libs gio-2.0 chafa fftw3f opus opusfile ogg vorbis vorbisfile glib-2.0 taglib)
+LIBS = -L/usr/lib -lm -lopusfile -lglib-2.0 -lpthread $(shell PKG_CONFIG_PATH=$(PKG_CONFIG_PATH) $(PKG_CONFIG) --libs gio-2.0 chafa fftw3f opus opusfile ogg vorbis vorbisfile glib-2.0 taglib)
 LIBS += -lstdc++
 
-LDFLAGS = -logg -lz -flto
+LDFLAGS = -logg -lz
 
 ifeq ($(UNAME_S), Linux)
   CFLAGS += -fPIE -fstack-clash-protection
@@ -87,6 +87,8 @@
   ifneq ($(DEBUG), 1)
   LDFLAGS += -s
   endif
+else ifeq ($(UNAME_S), Darwin)
+  LIBS += -framework CoreAudio -framework CoreFoundation
 endif
 
 # Conditionally add  USE_DBUS is enabled
@@ -119,8 +121,8 @@
 OBJDIR = src/obj
 
 SRCS = src/common_ui.c  src/common.c src/sound.c src/directorytree.c src/notifications.c \
-       src/soundcommon.c src/m4a.c src/search_ui.c  src/soundradio.c src/searchradio_ui.c  src/playlist_ui.c \
-       src/player.c src/soundbuiltin.c src/mpris.c src/playerops.c \
+       src/soundcommon.c src/m4a.c src/search_ui.c src/playlist_ui.c \
+       src/player_ui.c src/soundbuiltin.c src/mpris.c src/playerops.c \
        src/utils.c src/file.c src/imgfunc.c src/cache.c src/songloader.c \
        src/playlist.c src/term.c src/settings.c src/visuals.c src/kew.c
 
@@ -133,37 +135,23 @@
 
 all: kew
 
-# ALAC codec sources
-ALAC_SRCS_CPP = include/alac/codec/ALACDecoder.cpp include/alac/codec/alac_wrapper.cpp
-ALAC_SRCS_C = include/alac/codec/ag_dec.c include/alac/codec/ALACBitUtilities.c \
-              include/alac/codec/dp_dec.c include/alac/codec/EndianPortable.c \
-              include/alac/codec/matrix_dec.c
+# Generate object lists
+OBJS_C = $(SRCS:src/%.c=$(OBJDIR)/%.o)
 
-# Generate object lists
-OBJS_C = $(SRCS:src/%.c=$(OBJDIR)/%.o) $(ALAC_SRCS_C:include/alac/codec/%.c=$(OBJDIR)/alac/%.o)
-OBJS_CPP = $(ALAC_SRCS_CPP:include/alac/codec/%.cpp=$(OBJDIR)/alac/%.o)
+NESTEGG_SRCS = include/nestegg/nestegg.c
+NESTEGG_OBJS = $(NESTEGG_SRCS:include/nestegg/%.c=$(OBJDIR)/nestegg/%.o)
 
 # All objects together
-OBJS = $(OBJS_C) $(OBJS_CPP)
+OBJS = $(OBJS_C) $(NESTEGG_OBJS)
 
 # Create object directories
 $(OBJDIR):
-	mkdir -p $(OBJDIR) $(OBJDIR)/alac
+	mkdir -p $(OBJDIR)
 
 ## Compile C sources
 $(OBJDIR)/%.o: src/%.c Makefile | $(OBJDIR)
 	@mkdir -p $(dir $@)
 	$(CC) $(CFLAGS) $(DEFINES) -c -o $@ $<
-
-# Compile ALAC C files
-$(OBJDIR)/alac/%.o: include/alac/codec/%.c Makefile | $(OBJDIR)
-	@mkdir -p $(dir $@)
-	$(CC) $(CFLAGS) $(DEFINES) -c -o $@ $<
-
-# Compile ALAC C++ files
-$(OBJDIR)/alac/%.o: include/alac/codec/%.cpp Makefile | $(OBJDIR)
-	@mkdir -p $(dir $@)
-	$(CXX) $(CXXFLAGS) $(DEFINES) -c -o $@ $<
 
 # Compile explicit C++ sources in src/
 $(OBJDIR)/%.o: src/%.cpp Makefile | $(OBJDIR)
@@ -174,6 +162,11 @@
 $(WRAPPER_OBJ): $(WRAPPER_SRC) Makefile | $(OBJDIR)
 	@mkdir -p $(dir $@)
 	$(CXX) $(CXXFLAGS) $(DEFINES) -c $< -o $@
+
+# Compile C files in include/nestegg
+$(OBJDIR)/nestegg/%.o: include/nestegg/%.c Makefile | $(OBJDIR)
+	@mkdir -p $(dir $@)
+	$(CC) $(CFLAGS) $(DEFINES) -c -o $@ $<
 
 # Link all objects safely together using C++ linker
 kew: $(OBJS) $(WRAPPER_OBJ) Makefile

=== debian/changelog ===
kew (3.4.1+ds-1) unstable; urgency=medium

  * New upstream release

 -- Matthias Geiger <werdahias@debian.org>  Mon, 08 Sep 2025 20:19:16 +0200

## kew 3.5.2+ds

=== Makefile ===
--- 
+++ 
@@ -39,22 +39,39 @@
 # Default USE_FAAD to auto-detect if not set by user
 ifeq ($(origin USE_FAAD), undefined)
 
-  USE_FAAD = $(shell PKG_CONFIG_PATH=$(PKG_CONFIG_PATH) $(PKG_CONFIG) --exists faad && echo 1 || echo 0)
-
-  ifeq ($(USE_FAAD), 0)
-    # If pkg-config fails, try to find libfaad dynamically in common paths
-    USE_FAAD = $(shell [ -f /usr/lib/libfaad.so ] || [ -f /usr/local/lib/libfaad.so ] || \
-                       [ -f /opt/local/lib/libfaad.so ] || [ -f /opt/homebrew/lib/libfaad.dylib ] || \
-                       [ -f /opt/homebrew/opt/faad2/lib/libfaad.dylib ] || \
-                       [ -f /usr/local/lib/libfaad.dylib ] || [ -f /lib/x86_64-linux-gnu/libfaad.so.2 ] && echo 1 || echo 0)
-  endif
+  # Check if we're in Termux environment
+  ifneq ($(wildcard /data/data/com.termux/files/usr),)
+    # Termux environment - check common installation paths
+    USE_FAAD = $(shell [ -f "$(PREFIX)/lib/libfaad.so" ] || \
+                       [ -f "$(PREFIX)/lib/libfaad2.so" ] || \
+                       [ -f "$(PREFIX)/local/lib/libfaad.so" ] || \
+                       [ -f "$(PREFIX)/local/lib/libfaad2.so" ] || \
+                       [ -f "/data/data/com.termux/files/usr/lib/libfaad.so" ] || \
+                       [ -f "/data/data/com.termux/files/usr/bin/faad" ] || \
+                       [ -f "/data/data/com.termux/files/usr/lib/libfaad2.so" ] || \
+                       [ -f "/data/data/com.termux/files/usr/local/lib/libfaad.so" ] || \
+                       [ -f "/data/data/com.termux/files/usr/local/lib/libfaad2.so" ] && echo 1 || echo 0)
+  else
+    # Non-Android build - try pkg-config first
+    USE_FAAD = $(shell PKG_CONFIG_PATH=$(PKG_CONFIG_PATH) $(PKG_CONFIG) --exists faad && echo 1 || echo 0)
+
+    ifeq ($(USE_FAAD), 0)
+        # If pkg-config fails, try to find libfaad dynamically in common paths
+        USE_FAAD = $(shell [ -f /usr/lib/libfaad.so ] || [ -f /usr/lib64/libfaad.so ] || [ -f /usr/lib64/libfaad2.so ] || \
+                        [ -f /usr/bin/faad ] || [ -f /usr/local/lib/libfaad.so ] || \
+                        [ -f /opt/local/lib/libfaad.so ] || [ -f /opt/homebrew/lib/libfaad.dylib ] || \
+                        [ -f /opt/homebrew/opt/faad2/lib/libfaad.dylib ] || \
+                         [ -f /usr/local/lib/libfaad.dylib ] || [ -f /lib/x86_64-linux-gnu/libfaad.so.2 ] && echo 1 || echo 0)
+    endif
+  endif
+
 endif
 
 # Compiler flags
 COMMONFLAGS = -I/usr/include -I/opt/homebrew/include -I/usr/local/include -I/usr/lib -Iinclude/minimp4 \
-         -I/usr/include/chafa -I/usr/lib/chafa/include -I/usr/include/ogg -I/usr/include/opus \
+         -I/usr/include/chafa -I/usr/lib/chafa/include -I/usr/lib64/chafa/include -I/usr/include/ogg -I/usr/include/opus \
          -I/usr/include/stb -Iinclude/stb_image -I/usr/include/glib-2.0 \
-         -I/usr/lib/glib-2.0/include -Iinclude/miniaudio -Iinclude -Iinclude/nestegg -I/usr/include/gdk-pixbuf-2.0
+         -I/usr/lib/glib-2.0/include -I/usr/lib64/glib-2.0/include -Iinclude/miniaudio -Iinclude -Iinclude/nestegg -I/usr/include/gdk-pixbuf-2.0
 
 ifeq ($(DEBUG), 1)
 COMMONFLAGS += -g -DDEBUG
@@ -63,8 +80,16 @@
 endif
 
 COMMONFLAGS += $(shell PKG_CONFIG_PATH=$(PKG_CONFIG_PATH) $(PKG_CONFIG) --cflags gio-2.0 chafa fftw3f opus opusfile vorbis ogg glib-2.0 taglib)
+COMMONFLAGS += -DMA_NO_AAUDIO
 COMMONFLAGS += -fstack-protector-strong -Wformat -Werror=format-security -fPIE -D_FORTIFY_SOURCE=2
 COMMONFLAGS += -Wall -Wextra -Wpointer-arith
+
+  # Check if we're in Termux environment
+ifneq ($(wildcard /data/data/com.termux/files/usr),)
+  # Termux environment
+  COMMONFLAGS += -D__ANDROID__
+endif
+
 CFLAGS = $(COMMONFLAGS)
 
 # Compiler flags for C++ code
@@ -96,11 +121,16 @@
   DEFINES += -DUSE_DBUS
 endif
 
+DEFINES += -DPREFIX=\"$(PREFIX)\"
+
 # Conditionally add faad2 support if USE_FAAD is enabled
 ifeq ($(USE_FAAD), 1)
   ifeq ($(ARCH), arm64)
     CFLAGS += -I/opt/homebrew/opt/faad2/include
     LIBS += -L/opt/homebrew/opt/faad2/lib -lfaad
+  else ifeq ($(UNAME_O),Android)
+    CFLAGS += -I$(PREFIX)/include
+    LIBS += -L$(PREFIX)/lib -lfaad
   else
     CFLAGS += -I/usr/local/include
     LIBS += -L/usr/local/lib -lfaad
@@ -120,7 +150,7 @@
 
 OBJDIR = src/obj
 
-SRCS = src/common_ui.c  src/common.c src/sound.c src/directorytree.c src/notifications.c \
+SRCS = src/common_ui.c  src/common.c src/theme.c src/sound.c src/directorytree.c src/notifications.c \
        src/soundcommon.c src/m4a.c src/search_ui.c src/playlist_ui.c \
        src/player_ui.c src/soundbuiltin.c src/mpris.c src/playerops.c \
        src/utils.c src/file.c src/imgfunc.c src/cache.c src/songloader.c \
@@ -132,6 +162,8 @@
 
 MAN_PAGE = kew.1
 MAN_DIR ?= $(PREFIX)/share/man
+DATADIR ?= $(PREFIX)/share
+THEMEDIR = $(DATADIR)/kew/themes
 
 all: kew
 
@@ -176,13 +208,27 @@
 install: all
 	mkdir -p $(DESTDIR)$(MAN_DIR)/man1
 	mkdir -p $(DESTDIR)$(PREFIX)/bin
+	mkdir -p $(DESTDIR)$(THEMEDIR)
 	install -m 0755 kew $(DESTDIR)$(PREFIX)/bin/kew
 	install -m 0644 docs/kew.1 $(DESTDIR)$(MAN_DIR)/man1/kew.1
+	@if [ -d themes ]; then \
+		for theme in themes/*.theme; do \
+			if [ -f "$$theme" ]; then \
+				install -m 0644 "$$theme" $(DESTDIR)$(THEMEDIR)/; \
+			fi; \
+		done; \
+		for theme in themes/*.txt; do \
+			if [ -f "$$theme" ]; then \
+				install -m 0644 "$$theme" $(DESTDIR)$(THEMEDIR)/; \
+			fi; \
+		done; \
+	fi
 
 .PHONY: uninstall
 uninstall:
 	rm -f $(DESTDIR)$(PREFIX)/bin/kew
 	rm -f $(DESTDIR)$(MAN_DIR)/man1/kew.1
+	rm -rf $(DESTDIR)$(THEMEDIR)
 
 .PHONY: clean
 clean:

=== debian/changelog ===
kew (3.5.2+ds-2) unstable; urgency=medium

  * d/rules: Apply patch from helmut to fix FTCBS (Closes: #1115553)

 -- Matthias Geiger <werdahias@debian.org>  Mon, 13 Oct 2025 13:13:26 +0200

kew (3.5.2+ds-1) unstable; urgency=medium

  * d/watch: Switch to v5 and new codeberg upstream
  * d/u/metadata: Update for new codeberg location
  * d/control: Update Homepage for new codeberg location
  * d/gbp.conf: Fix upstream-vcs tags
  * New upstream release
  * d/control: Drop obsolete Rules-Require-Root field
  * d/copyright: Update, alac is no longer vendored

 -- Matthias Geiger <werdahias@debian.org>  Wed, 08 Oct 2025 22:10:22 +0200

=== debian/control ===
--- 
+++ 
@@ -2,7 +2,6 @@
 Section: sound
 Priority: optional
 Maintainer: Matthias Geiger <werdahias@debian.org>
-Rules-Requires-Root: no
 Build-Depends:
  debhelper-compat (= 13),
  libavformat-dev,
@@ -20,7 +19,7 @@
  libtag-dev,
  libvorbis-dev,
 Standards-Version: 4.7.2
-Homepage: https://github.com/ravachol/kew
+Homepage: https://codeberg.org/ravachol/kew
 Vcs-Browser: https://salsa.debian.org/debian/kew
 Vcs-Git: https://salsa.debian.org/debian/kew.git

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEBUG=1

include /usr/share/dpkg/architecture.mk

ARCH_MAP_i686 = i386

%:
	dh $@

override_dh_auto_build:
	dh_auto_build -- ARCH=$(or $(ARCH_MAP_$(DEB_HOST_GNU_CPU)),$(DEB_HOST_GNU_CPU))

## kew 3.6.4+ds

=== debian/changelog ===
kew (3.6.4+ds-1) unstable; urgency=medium

  * New upstream release
  * d/control: Require miniaudio >= 0.11.23
  * d/rules: Skip dwz; it fails otherwise

 -- Matthias Geiger <werdahias@debian.org>  Tue, 25 Nov 2025 20:51:04 +0100

=== debian/control ===
--- 
+++ 
@@ -11,7 +11,7 @@
  libfreeimage-dev,
  libglib2.0-dev,
  libnotify-dev,
- libminiaudio-dev (>= 0.11.21~~),
+ libminiaudio-dev (>= 0.11.23~~),
  libogg-dev,
  libopus-dev,
  libopusfile-dev,

=== debian/rules ===
--- 
+++ 
@@ -12,3 +12,5 @@
 
 override_dh_auto_build:
 	dh_auto_build -- ARCH=$(or $(ARCH_MAP_$(DEB_HOST_GNU_CPU)),$(DEB_HOST_GNU_CPU))
+
+override_dh_dwz:

## kew 3.7.3+ds

=== Makefile ===
--- 
+++ 
@@ -22,18 +22,16 @@
   endif
 endif
 
-# Adjust the PREFIX for macOS and Linux
-ifeq ($(UNAME_S), Darwin)
-    ifeq ($(ARCH), arm64)
-        PREFIX ?= /usr/local
+PREFIX    ?= /usr/local
+
+ifeq ($(UNAME_S),Darwin)
+    ifeq ($(ARCH),arm64)
         PKG_CONFIG_PATH := /opt/homebrew/lib/pkgconfig:/opt/homebrew/share/pkgconfig:$(PKG_CONFIG_PATH)
     else
-        PREFIX ?= /usr/local
         PKG_CONFIG_PATH := /usr/local/lib/pkgconfig:/usr/local/share/pkgconfig:$(PKG_CONFIG_PATH)
     endif
-else
-    PREFIX ?= /usr/local
-    PKG_CONFIG_PATH := /usr/lib/x86_64-linux-gnu/pkgconfig:/usr/lib/pkgconfig:/usr/share/pkgconfig:$(PKG_CONFIG_PATH)
+
+    export PKG_CONFIG_PATH
 endif
 
 # Default USE_FAAD to auto-detect if not set by user
@@ -53,7 +51,7 @@
                        [ -f "/data/data/com.termux/files/usr/local/lib/libfaad2.so" ] && echo 1 || echo 0)
   else
     # Non-Android build - try pkg-config first
-    USE_FAAD = $(shell PKG_CONFIG_PATH=$(PKG_CONFIG_PATH) $(PKG_CONFIG) --exists faad && echo 1 || echo 0)
+    USE_FAAD = $(shell $(PKG_CONFIG) --exists faad && echo 1 || echo 0)
 
     ifeq ($(USE_FAAD), 0)
         # If pkg-config fails, try to find libfaad dynamically in common paths
@@ -64,14 +62,26 @@
                          [ -f /usr/local/lib/libfaad.dylib ] || [ -f /lib/x86_64-linux-gnu/libfaad.so.2 ] && echo 1 || echo 0)
     endif
   endif
-
-endif
-
-# Compiler flags
-COMMONFLAGS = -I/usr/include -I/opt/homebrew/include -I/usr/local/include -I/usr/lib -Iinclude/minimp4 \
-         -I/usr/include/chafa -I/usr/lib/chafa/include -I/usr/lib64/chafa/include -I/usr/include/ogg -I/usr/include/opus \
-         -I/usr/include/stb -Iinclude/stb_image -I/usr/include/glib-2.0 \
-         -I/usr/lib/glib-2.0/include -I/usr/lib64/glib-2.0/include -Iinclude/miniaudio -Iinclude -Iinclude/nestegg -I/usr/include/gdk-pixbuf-2.0
+endif
+
+LOCAL_INC = \
+    -Isrc \
+    -Iinclude \
+    -Iinclude/minimp4 \
+    -Iinclude/stb_image \
+    -Iinclude/miniaudio \
+    -Iinclude/nestegg
+
+ifeq ($(UNAME_S),Darwin)
+    PKG_LIBS = gio-2.0 chafa fftw3f opus opusfile vorbis vorbisfile ogg glib-2.0 taglib gdk-pixbuf-2.0
+else
+    PKG_LIBS = gio-2.0 chafa fftw3f opus opusfile vorbis vorbisfile ogg glib-2.0 taglib
+endif
+
+PKG_CFLAGS  = $(shell $(PKG_CONFIG) --cflags $(PKG_LIBS))
+PKG_LDFLAGS = $(shell $(PKG_CONFIG) --libs $(PKG_LIBS))
+
+COMMONFLAGS = $(LOCAL_INC) $(PKG_CFLAGS)
 
 ifeq ($(DEBUG), 1)
 COMMONFLAGS += -g -DDEBUG
@@ -79,9 +89,8 @@
 COMMONFLAGS += -O2
 endif
 
-COMMONFLAGS += $(shell PKG_CONFIG_PATH=$(PKG_CONFIG_PATH) $(PKG_CONFIG) --cflags gio-2.0 chafa fftw3f opus opusfile vorbis ogg glib-2.0 taglib)
 COMMONFLAGS += -DMA_NO_AAUDIO
-COMMONFLAGS += -fstack-protector-strong -Wformat -Werror=format-security -fPIE -D_FORTIFY_SOURCE=2
+COMMONFLAGS += -fstack-protector-strong -Wformat -Wno-format-security -fPIE -D_FORTIFY_SOURCE=2
 COMMONFLAGS += -Wall -Wextra -Wpointer-arith
 
   # Check if we're in Termux environment
@@ -96,7 +105,7 @@
 CXXFLAGS = $(COMMONFLAGS) -std=c++11
 
 # Libraries
-LIBS = -L/usr/lib -lm -lopusfile -lglib-2.0 -lpthread $(shell PKG_CONFIG_PATH=$(PKG_CONFIG_PATH) $(PKG_CONFIG) --libs gio-2.0 chafa fftw3f opus opusfile ogg vorbis vorbisfile glib-2.0 taglib)
+LIBS = -lm -lopusfile -lglib-2.0 -lpthread $(PKG_LDFLAGS)
 LIBS += -lstdc++
 
 LDFLAGS = -logg -lz
@@ -150,20 +159,30 @@
 
 OBJDIR = src/obj
 
-SRCS = src/common_ui.c  src/common.c src/theme.c src/sound.c src/directorytree.c src/notifications.c \
-       src/soundcommon.c src/m4a.c src/search_ui.c src/playlist_ui.c \
-       src/player_ui.c src/soundbuiltin.c src/mpris.c src/playerops.c \
-       src/utils.c src/file.c src/imgfunc.c src/cache.c src/songloader.c \
-       src/playlist.c src/term.c src/settings.c src/visuals.c src/kew.c
+SRCS = src/common/appstate.c src/ui/common_ui.c src/common/common.c \
+       src/utils/utils.c src/utils/file.c src/utils/cache.c src/utils/term.c \
+       src/sound/sound.c src/sound/m4a.c src/sound/sound_builtin.c src/sound/audiobuffer.c \
+       src/sound/decoders.c src/sound/audio_file_info.c src/sound/playback.c src/sound/volume.c \
+       src/sys/sys_integration.c src/sys/notifications.c src/sys/mpris.c \
+       src/ops/playback_ops.c src/ops/playback_clock.c src/ops/playback_system.c \
+       src/ops/playlist_ops.c src/ops/library_ops.c src/ops/track_manager.c src/ops/playback_state.c \
+       src/ui/control_ui.c  src/ui/input.c src/ui/playlist_ui.c  src/ui/search_ui.c  src/ui/player_ui.c \
+       src/ui/visuals.c src/ui/chroma.c src/ui/queue_ui.c src/ui/settings.c  src/ui/cli.c \
+       src/data/theme.c src/data/directorytree.c src/data/lyrics.c src/data/img_func.c src/data/song_loader.c  \
+       src/data/playlist.c  src/kew.c
 
 # TagLib wrapper
-WRAPPER_SRC = src/tagLibWrapper.cpp
+WRAPPER_SRC = src/data/tagLibWrapper.cpp
 WRAPPER_OBJ = $(OBJDIR)/tagLibWrapper.o
 
 MAN_PAGE = kew.1
 MAN_DIR ?= $(PREFIX)/share/man
 DATADIR ?= $(PREFIX)/share
+LOCALEDIR ?= $(DATADIR)/locale
 THEMEDIR = $(DATADIR)/kew/themes
+THEMESRCDIR := $(CURDIR)/themes
+
+DEFINES += -DLOCALEDIR=\"$(LOCALEDIR)\"
 
 all: kew
 
@@ -206,18 +225,32 @@
 
 .PHONY: install
 install: all
+	# Create directories
 	mkdir -p $(DESTDIR)$(MAN_DIR)/man1
 	mkdir -p $(DESTDIR)$(PREFIX)/bin
 	mkdir -p $(DESTDIR)$(THEMEDIR)
+	mkdir -p $(DESTDIR)$(LOCALEDIR)/ja/LC_MESSAGES
+	mkdir -p $(DESTDIR)$(LOCALEDIR)/zh_CN/LC_MESSAGES
+
+	# Install binary and man page
 	install -m 0755 kew $(DESTDIR)$(PREFIX)/bin/kew
 	install -m 0644 docs/kew.1 $(DESTDIR)$(MAN_DIR)/man1/kew.1
-	@if [ -d themes ]; then \
-		for theme in themes/*.theme; do \
+
+	# Install Chinese translation
+	install -m 0644 locale/zh_CN/LC_MESSAGES/kew.mo \
+	$(DESTDIR)$(LOCALEDIR)/zh_CN/LC_MESSAGES/kew.mo
+
+	# Install Japanese translation
+	install -m 0644 locale/ja/LC_MESSAGES/kew.mo \
+	$(DESTDIR)$(LOCALEDIR)/ja/LC_MESSAGES/kew.mo
+
+	@if [ -d $(THEMESRCDIR) ]; then \
+	for theme in $(THEMESRCDIR)/*.theme; do \
 			if [ -f "$$theme" ]; then \
 				install -m 0644 "$$theme" $(DESTDIR)$(THEMEDIR)/; \
 			fi; \
 		done; \
-		for theme in themes/*.txt; do \
+		for theme in $(THEMESRCDIR)/*.txt; do \
 			if [ -f "$$theme" ]; then \
 				install -m 0644 "$$theme" $(DESTDIR)$(THEMEDIR)/; \
 			fi; \
@@ -229,7 +262,11 @@
 	rm -f $(DESTDIR)$(PREFIX)/bin/kew
 	rm -f $(DESTDIR)$(MAN_DIR)/man1/kew.1
 	rm -rf $(DESTDIR)$(THEMEDIR)
+	rm -f $(DESTDIR)$(LOCALEDIR)/ja/LC_MESSAGES/kew.mo
+	rm -f $(DESTDIR)$(LOCALEDIR)/zh_CN/LC_MESSAGES/kew.mo
 
 .PHONY: clean
 clean:
 	rm -rf $(OBJDIR) kew
+i18n:
+	$(MAKE) -f Makefile.i18n i18n

=== debian/changelog ===
kew (3.7.3+ds-1) unstable; urgency=medium

  * d/control: Opt into dh-compat 14
  * New upstream release
  * d/control: Bump S-V to 4.7.3; drop Priority field
  * d/patches: Rebase for new upstream
  * Add patch to build with system stb library

 -- Matthias Geiger <werdahias@debian.org>  Wed, 24 Dec 2025 00:14:46 +0100

=== debian/control ===
--- 
+++ 
@@ -1,9 +1,9 @@
 Source: kew
 Section: sound
-Priority: optional
 Maintainer: Matthias Geiger <werdahias@debian.org>
+X-DH-Compat: 14
 Build-Depends:
- debhelper-compat (= 13),
+ debhelper (>= 13.17),
  libavformat-dev,
  libchafa-dev,
  libfaad-dev,
@@ -18,7 +18,7 @@
  libstb-dev (>= 0.0~git20241109.5c20573+ds~~),
  libtag-dev,
  libvorbis-dev,
-Standards-Version: 4.7.2
+Standards-Version: 4.7.3
 Homepage: https://codeberg.org/ravachol/kew
 Vcs-Browser: https://salsa.debian.org/debian/kew
 Vcs-Git: https://salsa.debian.org/debian/kew.git
